/***************************************************************************
                          block.h  -  description
                             -------------------
    begin                : Fri May 16 2003
    copyright            : (C) 2003 by Marcus Beranek
    email                : marcus@beranek.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef BLOCK_H
#define BLOCK_H

#include "successor.h"
#include "successorlist.h"

#include <qobject.h>
#include <qptrlist.h>

class Successor;

/**Data-Module to hold information about:
Block-ID
Block-Name
Block-Function
Block-Documentaton
  *@author Marcus Beranek
  */

class Block : public QObject  {

public:
	Block();
	Block( int id );
	Block( Block& b );
	~Block();
	/** No descriptions */
	void addFollows( Successor &s );
	/** No descriptions */
	void addFollowedby( Successor &s );
	/** No descriptions */
	void addTypicalFollowedby( Successor &s );

	enum SendType { Send=1, Receive=2, Undef=3 };

	int ID;
	SendType Type;
	int Depth;
	bool visited;
	bool printed;
	QString Name;
	QString Description;
	QString Function;
	QString Command;
	QString State;
	QString Example;
	SuccessorList getTypicalFollowedby();
	SuccessorList getFollowedby();
	SuccessorList getFollows();

	SuccessorList fls;
	SuccessorList fby;
	SuccessorList typical;

protected:
	void init(int id);

private:
	// SuccessorList fls;
	// SuccessorList fby;
	// SuccessorList typical;

};

#endif
