/***************************************************************************
                          simulator.h  -  description
                             -------------------
    begin                : Mon Jun 2 2003
    copyright            : (C) 2003 by Marcus Beranek
    email                : marcus@beranek.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef SIMULATOR_H
#define SIMULATOR_H

#include <qvariant.h>
#include <qwidget.h>
#include <viewplugin.h>
#include <qptrlist.h>

class QVBoxLayout;
class QHBoxLayout;
class QGridLayout;
class QFrame;
class QLabel;
class QPushButton;
class QScrollView;
class QSplitter;
class QTextEdit;
class BlockBtn;
class QSpacerItem;

/**
  *@author Marcus Beranek
  */

class Simulator : public ViewPlugin  {
	Q_OBJECT
public:
	Simulator(QWidget *parent=0, const char *name=0);
	~Simulator();

	virtual void init( ShowState show);
	virtual void clear();

	QSplitter* splitter4;
	QFrame* frame6;
	QLabel* textLabel1;
	QScrollView* scrollView2;
	QPushButton* pushButton1;
	QPushButton* pushButton2;
	QFrame* frame7;
	QTextEdit* textEdit1;
	QFrame* frame6_2;
	QLabel* textLabel1_2;
	QScrollView* scrollView2_2;
	QPushButton* pushButton1_2;
	QPushButton* pushButton2_2;

protected:
	QHBoxLayout* Form1Layout;
	QVBoxLayout* frame6Layout;
	QHBoxLayout* frame7Layout;
	QVBoxLayout* frame6_2Layout;
	QVBoxLayout* send_Layout;
	QVBoxLayout* receive_Layout;
	void getButtons( int blockid );

protected slots:
	virtual void languageChange();
	void blockSelected( int blockid );
	
private:
	QPtrList<BlockBtn> bbl;
	QPtrList<QSpacerItem> spl;
	
	QFrame* buttonbox_send;
	QFrame* buttonbox_receive;

	int max_width_send;
	int max_width_receive;
};

#endif
