/***************************************************************************
                          blockdisplay.cpp  -  description
                             -------------------
    begin                : Sat May 24 2003
    copyright            : (C) 2003 by Marcus Beranek
    email                : marcus@beranek.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "blockdisplay.h"

#include <iostream>
#include <iomanip>

BlockDisplay::BlockDisplay()
{
	ID = 0;
	BlockID = 0;
	Name = "";
	
	// TODO: Koordinaten berprfen, die stimmen noch nicht so ganz... :(
	
	x1 = 0; // oben links
	y1 = 0; // oben links
	x2 = 0; // unten rechts
	y2 = 0; // unten rechts

	left_x = 0; // Linie links
	left_y = 0; // Linie links

	right_x = 0; // Linie rechts
	right_y = 0; // Linie rechts
	
}

BlockDisplay::BlockDisplay(QString n, int id, int blockid, int x, int y)
{
	ID = id;
	BlockID = blockid;
	Name = n;

	x1 = x; // oben links
	y1 = y; // oben links

	recalculatePoints();

//	std::cout << "right-x: " << right_x << " right_y: " << right_y << endl;
	
}

BlockDisplay::BlockDisplay(int id)
{
	ID = id;
	Name = "";

	x1 = 0; // oben links
	y1 = 0; // oben links
	x2 = 0; // unten rechts
	y2 = 0; // unten rechts

	left_x = 0; // Linie links
	left_y = 0; // Linie links

	right_x = 0; // Linie rechts
	right_y = 0; // Linie rechts
}



BlockDisplay::~BlockDisplay(){
}


void BlockDisplay::recalculatePoints()
{
  int charwidth = 12;  // leave 12 pixel for each character...
  int charheight = 10; // leave 12 pixel for each character...
  int spacex = 10; // leave space...
  int spacey = 5; // leave space...
    
  int len = Name.length();

  x2 = x1 + len * charwidth + spacex;
  y2 = y1 - (charheight + spacey); // assuming we have only one line...

  right_x = x2;
  right_y = y2 + ( (int) ( (charheight+spacey) / 2  ) );

  left_x = x1;
  left_y = right_y;
  
}


void BlockDisplay::setName( QString n )
{
  Name = n;
  recalculatePoints();
}

