/***************************************************************************
                          display.cpp  -  description
                             -------------------
    begin                : Tue Jun 3 2003
    copyright            : (C) 2003 by Marcus Beranek
    email                : marcus@beranek.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "display.h"
#include "blockdisplay.h"
#include "blockdisplaylist.h"
#include "blockline.h"
#include "blocklinelist.h"
#include "treedisplay.h"

#include <qpainter.h>

TDisplay::TDisplay(QWidget *parent, const char *name ) : QWidget(parent,name) 
{
	
}
//---------------------------------------------------------------------------


TDisplay::~TDisplay()
{
	
}
//---------------------------------------------------------------------------


void TDisplay::paintEvent( QPaintEvent * )
{
	QPainter p( this );
	p.setBrush( white );
	p.drawRect( 0,0, width(), height() );


	p.setPen( black );

	// 1. alle Blocks malen:
	BlockDisplay* disp;
	for( disp = b->first(); disp; disp = b->next()){
		// TODO: rectangle around text.
		//
		// unfortnatly, the coordinates are wrong:
		// p.drawRect( disp->left_x, disp->left_y, disp->right_x, disp->right_y );
		//
		p.drawText( disp->x1 + 10, disp->y1, disp->Name );
	}

	// 2. alle Linien ziehen:
	BlockLine* line;
	for( line = l->first(); line; line = l->next()){
		p.setPen( NoPen );
		p.moveTo( line->x1, line->y1 );
		p.setPen( black );
		p.lineTo( line->x2, line->y2 );
	}
	
	p.setPen( NoPen );
	
}
//---------------------------------------------------------------------------


void TDisplay::setBlockDisplayList( BlockDisplayList* b_list)
{
	b = b_list;
}
//---------------------------------------------------------------------------


void TDisplay::setBlockLineList( BlockLineList* l_list)
{
	l = l_list;
}
//---------------------------------------------------------------------------



