/***************************************************************************
                          successorlist.cpp  -  description
                             -------------------
    begin                : Fri May 16 2003
    copyright            : (C) 2003 by Marcus Beranek
    email                : marcus@beranek.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

//
// **************************
// * QPtrList of Successors *
// **************************
//
// Successors are compared by their IDs. So we have to implement the
// virtual "compareItems"-method to sort the list or to use the
// insertion-sort of the QPtrList.
//
 
#include "successorlist.h"
#include "successor.h"

#include <qptrlist.h>

SuccessorList::SuccessorList(){
}

SuccessorList::~SuccessorList(){
}


int SuccessorList::compareItems( QPtrCollection::Item item1, QPtrCollection::Item item2 )
{
	Successor* s1 = (Successor*) item1;
	Successor* s2 = (Successor*) item2;

	int comp = 0;

	if( s1->ID  == s2->ID ){ comp = 0; }
	if( s1->ID  <  s2->ID ){ comp = -1; }
	if( s1->ID  >  s2->ID ){ comp = 1; }

	return comp;

}

