/***************************************************************************
                          treedisplay.h  -  description
                             -------------------
    begin                : Sat May 24 2003
    copyright            : (C) 2003 by Marcus Beranek
    email                : marcus@beranek.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef TREEDISPLAY_H
#define TREEDISPLAY_H

#include "viewplugin.h"

#include "display.h"

#include <qwidget.h>
#include <qptrlist.h>

class QString;
class BlockDisplayList;
class BlockLineList;
class BlockList;
class QScrollView;
class QHBoxLayout;


/**
  *@author Marcus Beranek
  */

//class TreeDisplay : public QWidget  {
class TreeDisplay : public ViewPlugin  {

public:
	TreeDisplay(QWidget *parent=0, const char *name=0);
	~TreeDisplay();
	void clear();
	QSizePolicy sizePolicy() const;
	void addBlockList( BlockList* blist);
	void init( ViewPlugin::ShowState show );
	void setBlockList( BlockList* b);
	friend void TDisplay::paintEvent(QPaintEvent *);

protected:
	void recalculateLines();
	// void paintEvent( QPaintEvent * );
	
	void addBlockCoord(QString n, int id, int blockid, int x, int y);
	void addLine(int id1, int id2);
	virtual void addBlock(Block * block);

	void flowChart( BlockList* blist, Block* b, ViewPlugin::ShowState show, int x_pos, int y_pos, int oldID=0  );

private:

	QWidget* screen;
	BlockDisplayList* b;
	BlockLineList* l;
	
	TDisplay* t_disp;
	
	int w;
	int h;

//	BlockList* bl;

	int treeview_y_coord;
	int treeview_x_coord;
	int max_button_width;
	int max_button_height;
	int max_x;
	int max_y;
	int spacex;
	int spacey;

	int col;
	int row;

	int newID;
	QScrollView* tree;
	QHBoxLayout* treeLayout;
};

#endif
