/***************************************************************************
                          viewplugin.cpp  -  description
                             -------------------
    begin                : Sat May 31 2003
    copyright            : (C) 2003 by Marcus Beranek
    email                : marcus@beranek.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "viewplugin.h"

#include "blocklist.h"
#include "block.h"

ViewPlugin::ViewPlugin(QWidget *parent, const char *name ) : QWidget(parent,name)
{
  	bl = new BlockList();
}



ViewPlugin::~ViewPlugin()
{
  
}



/** This method is used to reset the protocol-display of the plugin. */
void ViewPlugin::clear()
{
  
}


/** This method is used to inititalize the display of the typical or complete view of the protocol... */
void ViewPlugin::init( ShowState show)
{
  
}


void ViewPlugin::addBlock(Block * block)
{
//	checkBlock( "addBlock", block );
	Block* x = new Block( *block);
	x->fby.clear();      // Problems in Block-CC with QPtrList...
	x->fls.clear();      // Problems in Block-CC with QPtrList...
	x->typical.clear();  // Problems in Block-CC with QPtrList...
	bl->append( x );
}

void ViewPlugin::checkBlock( QString from, Block* b )
{
	std::cout << "Plugin Treedisplay, Check Block: " << endl;
	std::cout << "calling from: " << from << endl;
	std::cout << "-------------------------------- " << endl;
	std::cout << "ID " << b->ID << endl;
	std::cout << "Name " << b->Name << endl;
	std::cout << "Command " << b->Command << endl;
	std::cout << "Type " << b->Type << endl;
	
	SuccessorList sl = b->getFollowedby();
	Successor* x;
	
	std::cout << "Followed by: " ;
	if( ! sl.isEmpty() ){
		for(  x = sl.first(); x; x = sl.next() ){
			std::cout << x->ID << ", ";
		}
		std::cout << endl;
	}
	
	std::cout << "Follows: " ;
	sl = b->getFollows();
	if( ! sl.isEmpty() ){
		for( x = sl.first(); x; x = sl.next() ){
			std::cout << x->ID << ", ";
		}
		std::cout << endl;
	}
	
	std::cout << "Typically followed by: " ;
	sl = b->getTypicalFollowedby();
	if( ! sl.isEmpty() ){
		for( x = sl.first(); x; x = sl.next() ){
			std::cout << x->ID << ", ";
		}
		std::cout << endl;
	}
	
	std::cout << endl << "-------------------------------- " << endl;
	
}
//---------------------------------------------------------------------------

void ViewPlugin::addBlockFollowedby(int blockid, int followerid)
{
	int z = bl->find( new Block( blockid ) );
	if( z > -1 ){
		Successor* s = new Successor();
		s->ID = followerid;
		Block* b = (Block*) bl->at( z );
		b->addFollowedby( *s );
		// checkBlock("corrected block", b );
	}
}


void ViewPlugin::addBlockFollows(int blockid, int followerid)
{
	int z = bl->find( new Block( blockid ) );
	if( z > -1 ){
		Successor* s = new Successor();
		s->ID = followerid;
		Block* b = (Block*) bl->at( z );
		b->addFollows( *s );
	}
}

void ViewPlugin::addBlockTypicalFollowedby(int blockid, int followerid)
{
	int z = bl->find( new Block( blockid ) );
	if( z > -1 ){
		Successor* s = new Successor();
		s->ID = followerid;
		Block* b = (Block*) bl->at( z );
		b->addTypicalFollowedby( *s );
	}
}





