/***************************************************************************
                          viewplugin.h  -  description
                             -------------------
    begin                : Sat May 31 2003
    copyright            : (C) 2003 by Marcus Beranek
    email                : marcus@beranek.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef VIEWPLUGIN_H
#define VIEWPLUGIN_H

#include <qwidget.h>

class BlockList;
class Block;
class Successor;
class QString;

/**Generic Plugin to view a protocol...
  *@author Marcus Beranek
  */
  
class ViewPlugin : public QWidget  {

public: 
	ViewPlugin(QWidget *parent=0, const char *name=0);
	~ViewPlugin();
	
	enum ShowState { ShowTypical=1, ShowAll=2 };
	
  /** This method is used to inititalize the display of the typical or complete view of the protocol... */
  virtual void init( ShowState show);
  
  /** This method is used to reset the protocol-display of the plugin. */
  virtual void clear();
  
  /** No descriptions */
  virtual void addBlock(Block * block);

  virtual void addBlockFollowedby(int blockid, int followerid);
  virtual void addBlockFollows(int blockid, int followerid);
  virtual void addBlockTypicalFollowedby(int blockid, int followerid);


protected:
	BlockList* bl;
	void checkBlock( QString from, Block* b );

};


typedef ViewPlugin* create_t(QWidget*);
typedef void destroy_t(ViewPlugin*);


#endif
